import java.util.ArrayList;
import java.util.HashMap;


class AttributeValues {
    // index of the values
    protected HashMap<String, Integer> indexes;

    // names of the values 
    protected ArrayList<String> names;

    /**
     *   Constructor
     */
    public AttributeValues() {
	indexes = new HashMap<String, Integer>();
	names = new ArrayList<String>();
    }

    /**
     *  Add a new value, return the corresponding index
     */
    public int add(String value) {
	if (!indexes.containsKey(value)) {
	    names.add(value);
	    indexes.put(value, new Integer(names.size() - 1));
	    return names.size() - 1;
	} else {
	    return indexes.get(value).intValue();
	}
    }

    /**
     *  get the id of the value
     */
    public int getId(String value) {
	if (!indexes.containsKey(value)) {
	    return -1;
	} else {
	    return indexes.get(value).intValue();
	}
    }
    
    /**
     *  get the name of the id
     */
    public String getName(int i) {
	if (i < names.size()) {
	    return names.get(i);
	} else {
	    return "none";
	}
    }
    
    /**
     *  value Exist?
     */
    public boolean exist(String value) {
	return indexes.containsKey(value); 
    }
    
    /**
     *  to have all the values
     */
    public ArrayList<String> getValues() {
	return names;
    }

    /**
     * Number of indexes/values
     */
    public int size() {
	return indexes.size();
    }
}
