import java.util.ArrayList;

class DecisionTree {
	// the root of the decision tree
	public Node root;
	
	public DecisionTree() {
		root = null;
	}
	
	public void setRoot(Node root) {
		this.root = root;
	}
	
	/**
	 *     Design of the random decision tree
	 */
	public void learnRandomTree(DataFrame df, String targetName) {
		// learning attributes
		ArrayList<Integer> attributes = new ArrayList<Integer>(); 
		// target attribute to predict
		int target = -1;
		
		ArrayList<String> names = df.getNames();
		for(int i = 0; i < names.size(); i++) {
	    if (names.get(i).compareTo(targetName) != 0)
				attributes.add(new Integer(i));
	    else
				target = i;
		}
		
		// learn using randomTree
		root = randomTree(df, target, attributes);
	}
	
	/**
	 *     Design of the decision tree with ID3
	 */
	public void learnID3(DataFrame df, String targetName) {
		// learning attributes
		ArrayList<Integer> attributes = new ArrayList<Integer>(); 
		// target attribute to predict
		int target = -1;
		
		ArrayList<String> names = df.getNames();
		for(int i = 0; i < names.size(); i++) {
	    if (names.get(i).compareTo(targetName) != 0)
				attributes.add(new Integer(i));
	    else
				target = i;
		}
		
		// learn using id3
		root = id3(df, target, attributes);
	}
	
	/**
	 *     prediction using the decision tree
	 *       of all example in the data frame
	 */
	public ArrayList<String> predict(DataFrame df) {
		ArrayList<String> prediction = new ArrayList<String>();
		
		for(int i = 0; i < df.size(); i++)
	    prediction.add(predict(root, df.getExample(i)));
		
		return prediction;
	}
	
	/**
	 *  TO DO
	 *
	 *     prediction of class using the decision tree
	 *       of the example
	 */
	public String predict(Node node, Example example) {
		if (root == null)
	    return "null";
		
		return "none";
	}
	
	/**
	 *  TO DO
	 *
	 *     Design a "random" tree
	 *       
	 */    
	public Node randomTree(DataFrame df, int target, ArrayList<Integer> attributes) {
		return null;
	}
	
	/**
	 *  TO DO
	 *
	 *     learning using ID3 algorithm
	 *       
	 */    
	public Node id3(DataFrame df, int target, ArrayList<Integer> attributes) {
		return null;
	}
	
	/**
	 *  Print
	 */
	public String toString() {
		if (root != null)
	    return root.toString();
		else
	    return "()";
	}
	
}
